package org.processmining.models.graphbased.directed.socialnetwork;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.AbstractDirectedGraphEdge;

public class SNEdge extends AbstractDirectedGraphEdge<SNNode, SNNode> {

	/**
	 * This field identifies the relationship, i.e. it is the object
	 * corresponding to this relationship.
	 */
	private final Object identifier;

	public SNEdge(SNNode source, SNNode target, Object identifier) {
		super(source, target);
		this.identifier = identifier;
		getAttributeMap().put(AttributeMap.LABEL, identifier.toString());
		getAttributeMap().put(AttributeMap.EDGEEND, ArrowType.ARROWTYPE_SIMPLE);
		getAttributeMap().put(AttributeMap.EDGEENDFILLED, true);
		getAttributeMap().put(AttributeMap.SHOWLABEL, true);

	}

	// The type-cast is safe, since the super.equals(o) tests for class
	// equivalence
	public boolean equals(Object o) {
		return super.equals(o) && identifier.equals(((SNEdge) o).identifier);
	}

	public Object getIdentifier() {
		return identifier;
	}

	public double getWeight() {
		String str = getLabel();
		return Double.valueOf(str.substring(str.indexOf(":") + 1, str.length()));
	}
}