package org.processmining.models.graphbased.directed.socialnetwork;

import java.util.Collection;

import org.processmining.models.graphbased.directed.DirectedGraph;

public interface SocialNetwork extends DirectedGraph<SNNode, SNEdge> {

	String getLabel();

	// edge
	boolean addSNEdge(SNNode fromNode, SNNode toNode, Object identifier);

	boolean addSNEdge(Object fromNodeID, Object toNodeID, Object identifier);

	Object removeSNEdge(SNNode fromState, SNNode toState, Object identifier);

	Collection<SNEdge> getSNEdges();

	double getMaxFlowValue();

	double getMinFlowValue();

	// node
	boolean addSNNode(Object identifier);

	Object removeSNNode(Object identifier);

	Collection<SNNode> getSNNodes();

}
